﻿Imports Infragistics.Controls.Menus
Imports System.Collections.ObjectModel
Imports Infragistics.Windows

Class MainWindow

    Private itemHierarchy As List(Of String)
    Private ViewModel As ViewModel
    Private ClickedLevel As String

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()


        ViewModel = New ViewModel()
        Me.DataContext = ViewModel
        'BuildSelectedMenuTree()
        ' Add any initialization after the InitializeComponent() call.


        EventManager.RegisterClassHandler(GetType(XamDataTreeNodeControl), XamDataTreeNodeControl.ContextMenuOpeningEvent, New ContextMenuEventHandler(AddressOf ContextMenu_Opening))
        EventManager.RegisterClassHandler(GetType(MenuItem), MenuItem.ClickEvent, New RoutedEventHandler(AddressOf ContextMenu_Clicked))



    End Sub

    Private Sub _MenuTree_NodeCheckedChanged(sender As Object, e As Infragistics.Controls.Menus.NodeEventArgs)

        Me._SelectedMenuTree.ItemsSource = Me.ViewModel.SelectedCopy
        'BuildSelectedMenuTree()
        'Me._SelectedMenuTree.Nodes(0).IsExpanded = True

        '   MessageBox.Show(Me.ViewModel.SelectedMenuItems.Count.ToString)
        '   MessageBox.Show(Me.ViewModel.SelectedCopy.Count.ToString)

    End Sub

    Private Sub _MenuTree_MouseLeftButtonDown(sender As Object, e As MouseButtonEventArgs)

        If TypeOf (sender) Is XamDataTree Then
            Dim tree As XamDataTree = DirectCast(sender, XamDataTree)
            Dim nodeClicked As XamDataTreeNode = tree.ActiveNode
            If Not IsNothing(nodeClicked) AndAlso Not IsNothing(nodeClicked.Data) Then MessageBox.Show(DirectCast(nodeClicked.Data, clsMenuItem).Description.ToString)
            ClickedLevel = "Tree"
        End If

        If TypeOf (sender) Is XamDataTreeNodeControl Then
            Dim nodeControl As XamDataTreeNodeControl = DirectCast(sender, XamDataTreeNodeControl)
            Dim nodeClicked As XamDataTreeNode = nodeControl.Node
            MessageBox.Show(nodeClicked.Data.ToString)
            ClickedLevel = "Node"
        End If
        'DirectCast(sender, XamDataTree).SelectionSettings.SelectedNodes.Clear()
        'MessageBox.Show("You selected: " + Environment.NewLine() + "sender: " + sender.ToString + _
        '					Environment.NewLine() + "Source: " + e.Source.ToString + _
        '					Environment.NewLine() + "Original Source: " + e.OriginalSource.ToString)
        'Dim t = Utilities.GetAncestorFromType(e.OriginalSource, GetType(XamDataTreeNodeControl), True)
    End Sub

    Private Sub ContextMenu_Opening(sender As Object, e As RoutedEventArgs)

        Dim node = DirectCast(e.Source, XamDataTreeNodeControl)

        If node.Node.HasChildren Then

        End If


        'If ClickedLevel = "Tree" Then
        '    For Each mitem As MenuItem In Me._SelectedMenuTree.ContextMenu.Items
        '        ' if menu item is "Expand All", "Collapse All" or "Remove All" then visible = true otherwise false
        '    Next
        'End If

        'If ClickedLevel = "Node" Then
        '    ' if menu item is "Expand", "Collapse" or "Remove" then visible = true otherwise false
        'End If


    End Sub

    Private Sub ContextMenu_Closed(sender As Object, e As RoutedEventArgs)

        DirectCast(DirectCast(sender, ContextMenu).Tag, XamDataTreeNode).Control.Tag = "false"
    End Sub

    Private Sub ContextMenu_Clicked(sender As Object, e As RoutedEventArgs)

        If TypeOf (sender) Is MenuItem Then
            Dim menuItem As MenuItem = DirectCast(sender, MenuItem)
            '' which node did I click?
            Dim clickedNode As XamDataTreeNodeControl = DirectCast(menuItem.Parent, ContextMenu).PlacementTarget
            MessageBox.Show("You clicked: " + DirectCast(clickedNode.Node.Data, clsMenuItem).Description.ToString())
        End If

    End Sub

    Private Sub ContextMenu_Loaded(sender As Object, e As RoutedEventArgs)

        'Dim obj As Object = sender
        'Dim nd As XamDataTreeNode = DirectCast(DirectCast(sender, ContextMenu).Tag, XamDataTreeNode)
        'MessageBox.Show("You clicked on the menu item with Date: " + nd.Data.ToString())
    End Sub

    

End Class
